#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <string.h>
#include <pthread.h>
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
#include <SDL/SDL_audio.h>
#include <SDL/SDL_timer.h>
#include <linux/videodev.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <errno.h>
#include <fcntl.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include <X11/Xlib.h>
#include <SDL/SDL_syswm.h>
#include "v4l2uvc.h"
#include "gui.h"
#include "utils.h"
#include "color.h"
/* Fixed point arithmetic */
#define FIXED Sint32
#define FIXED_BITS 16
#define TO_FIXED(X) (((Sint32)(X))<<(FIXED_BITS))
#define FROM_FIXED(X) (((Sint32)(X))>>(FIXED_BITS))

#define INCPANTILT 64 // 1get_pic
int count_check=1;
int count1,count2;
unsigned long i;
typedef enum action_gui {
 /* 0..7..15 action top */
    A_BRIGHTNESS_UP,
    A_CONTRAST_UP,
    A_SATURATION_UP,
    A_GAIN_UP,
    A_SHARPNESS_UP,
    A_GAMMA_UP,
    A_SCREENSHOT,
    A_RESET,
    A_PAN_UP,
    A_TILT_UP,
    A_PAN_RESET,
    A_SWITCH_LIGHTFREQFILT,
    A_EXPOSURE_UP,
    A_EXPOSURE_ON,
    A_BALANCE_UP,
    A_BALANCE_ON,
 /* 8..15 -> 16..31 action bottom */
    A_BRIGHTNESS_DOWN,
    A_CONTRAST_DOWN,
    A_SATURATION_DOWN,
    A_GAIN_DOWN,
    A_SHARPNESS_DOWN,
    A_GAMMA_DOWN,
    A_RECORD_TOGGLE,
    A_QUIT,
    A_PAN_DOWN,
    A_TILT_DOWN,
    A_TILT_RESET,
    A_NOT1_DOWN,
    A_EXPOSURE_DOWN,
    A_EXPOSURE_OFF,
    A_BALANCE_DOWN,
    A_BALANCE_OFF,
 /* 16.. action others */
    A_VIDEO,
    A_CAPTURE_FRAME,
    A_CAPTURE_STREAM,
    A_CAPTURE_FRAMESTREAM,
    A_SAVE,
    A_LOAD,
    A_LAST
} action_gui;

typedef struct act_title {
	action_gui action;
	char * title;
} act_title;

typedef struct key_action_t {
    SDLKey key;
    action_gui action;
} key_action_t;

key_action_t keyaction[] = {
    {SDLK_n, A_BRIGHTNESS_UP},
    {SDLK_b, A_BRIGHTNESS_DOWN},
    {SDLK_x, A_CONTRAST_UP},
    {SDLK_w, A_CONTRAST_DOWN},
    {SDLK_c, A_SATURATION_UP},
    {SDLK_v, A_SATURATION_DOWN},
    {SDLK_z, A_GAIN_UP},
    {SDLK_a, A_GAIN_DOWN},
    {SDLK_r, A_SHARPNESS_UP},
    {SDLK_e, A_SHARPNESS_DOWN},
    {SDLK_y, A_PAN_UP},
    {SDLK_t, A_PAN_DOWN},
    {SDLK_s, A_SCREENSHOT},
    {SDLK_p, A_RECORD_TOGGLE},
    {SDLK_f, A_SWITCH_LIGHTFREQFILT},
    {SDLK_l, A_RESET},
    {SDLK_q, A_QUIT},
    {SDLK_m, A_VIDEO},
    {SDLK_f, A_CAPTURE_FRAME},
    {SDLK_i, A_CAPTURE_STREAM},
    {SDLK_j, A_CAPTURE_FRAMESTREAM},
    {SDLK_F1, A_SAVE},
    {SDLK_F2, A_LOAD}    
};
act_title title_act[A_LAST] ={
/* 0..7..15 action top */
   { A_BRIGHTNESS_UP,"Brightness Up"},
   { A_CONTRAST_UP,"Contrast Up"},
   { A_SATURATION_UP,"Saturation Up"},
   { A_GAIN_UP,"Gain_Up"},
   { A_SHARPNESS_UP,"Sharpness Up"},
   { A_GAMMA_UP,"Gamma Up"},
   { A_SCREENSHOT,"Take a Picture!!"},
   { A_RESET,"Reset All to Default !!"},
   { A_PAN_UP,"Pan +angle"},
   { A_TILT_UP,"Tilt +angle"},
   { A_PAN_RESET,"Pan reset"},
   { A_SWITCH_LIGHTFREQFILT,"Switch light freq filter"},
   { A_EXPOSURE_UP,"Exposure Up"},
   { A_EXPOSURE_ON,"Auto Exposure On"},
   { A_BALANCE_UP,"White Balance Up"},
   { A_BALANCE_ON,"Auto White Balance On"},
/* 8..15 -> 16..31 action bottom */
   { A_BRIGHTNESS_DOWN,"Brightness Down"},
   { A_CONTRAST_DOWN,"Contrast Down"},
   { A_SATURATION_DOWN,"Saturation Down"},
   { A_GAIN_DOWN,"Gain Down"},
   { A_SHARPNESS_DOWN,"Sharpness Down"},
   { A_GAMMA_DOWN,"Gamma Down"},
   { A_RECORD_TOGGLE,"AVI Start/Stop"},
   { A_QUIT,"Quit Happy, Bye Bye:)"},
   { A_PAN_DOWN,"Pan -angle"},
   { A_TILT_DOWN,"Tilt -angle"},
   { A_TILT_RESET,"Tilt Reset"},
   { A_NOT1_DOWN,"Nothing"},
   { A_EXPOSURE_DOWN,"Exposure Down"},
   { A_EXPOSURE_OFF,"Auto Exposure OFF"},
   { A_BALANCE_DOWN,"White Balance Down"},
   { A_BALANCE_OFF,"Auto White Balance OFF"},
/* 16.. action others */
   { A_VIDEO,"LUVCview(c)Laurent Pinchart && Michel Xhaard"},
   { A_CAPTURE_FRAME, "Single frame captured" },
   { A_CAPTURE_STREAM, "Stream capture" },
   { A_CAPTURE_FRAMESTREAM, "Frame stream capture" },
   { A_SAVE, "Saved Configuration" },
   { A_LOAD, "Restored Configuration" }
};
static const char version[] = VERSION;
struct vdIn *videoIn2;


struct pt_data {
    SDL_Surface **ptscreen;
    SDL_Event *ptsdlevent;
    SDL_Rect *drect;
    struct vdIn *ptvideoIn;
    unsigned char frmrate;
    SDL_mutex *affmutex;
} ;//ptdata;
struct pt_data ptdata2;

static int eventThread(void *data);
static Uint32 SDL_VIDEO_Flags =
    SDL_ANYFORMAT | SDL_DOUBLEBUF | SDL_RESIZABLE;
    

int main(/*int argc, char *argv[]*/)
{
    const SDL_VideoInfo *info2;
    char driver2[128];
    SDL_Surface *pscreen2;
    SDL_Overlay *overlay2;
    SDL_Rect drect2;
    SDL_Event sdlevent2;
    SDL_Thread *mythread2;
    SDL_mutex *affmutex2;

    int status2;
    Uint32 currtime2;
    Uint32 lasttime2;
    unsigned char *p2 = NULL;
    int hwaccel2 = 0;
    const char *videodevice2 = NULL;
    const char *mode2 = NULL;
    int format = V4L2_PIX_FMT_YUYV; //default̃tH[}bgyuyyɕύX
    int i;
    int grabmethod = 1;
    int width = 320;
    int height = 240;
    int fps = 15;
    unsigned char frmrate = 0;
    char *avifilename2 = NULL;
    int queryformats2 = 0;
    int querycontrols2 = 0;
    int readconfigfile2 = 0;
   // char *separateur;
    //char *sizestring = NULL;
     //char *fpsstring  = NULL;
    int enableRawStreamCapture2 = 0;
    int enableRawFrameCapture2 = 0;



    
    
    /************* Test SDL capabilities ************/
    if (SDL_Init(SDL_INIT_VIDEO) < 0) {
	fprintf(stderr, "Couldn't initialize SDL: %s\n", SDL_GetError());
	exit(1);
    }
    
    /* For this version, we'll be save and disable hardware acceleration */
    if(hwaccel2)
     if ( ! getenv("SDL_VIDEO_YUV_HWACCEL") ) {
        putenv("SDL_VIDEO_YUV_HWACCEL=0");
     }
     
   if (SDL_VideoDriverName(driver2, sizeof(driver2))) {
	printf("Video driver: %s\n", driver2);
    }
    info2 = SDL_GetVideoInfo();

    if (info2->wm_available) {
	printf("A window manager is available\n");
    }
    if (info2->hw_available) {
	printf("Hardware surfaces are available (%dK video memory)\n",
	       info2->video_mem);
	SDL_VIDEO_Flags |= SDL_HWSURFACE;
    }
    if (info2->blit_hw) {
	printf("Copy blits between hardware surfaces are accelerated\n");
	SDL_VIDEO_Flags |= SDL_ASYNCBLIT;
    }
    if (info2->blit_hw_CC) {
	printf
	    ("Colorkey blits between hardware surfaces are accelerated\n");
    }
    if (info2->blit_hw_A) {
	printf("Alpha blits between hardware surfaces are accelerated\n");
    }
    if (info2->blit_sw) {
	printf
	    ("Copy blits from software surfaces to hardware surfaces are accelerated\n");
    }
    if (info2->blit_sw_CC) {
	printf
	    ("Colorkey blits from software surfaces to hardware surfaces are accelerated\n");
    }
    if (info2->blit_sw_A) {
	printf
	    ("Alpha blits from software surfaces to hardware surfaces are accelerated\n");
    }
    if (info2->blit_fill) {
	printf("Color fills on hardware surfaces are accelerated\n");
    }

    if (!(SDL_VIDEO_Flags & SDL_HWSURFACE))
	SDL_VIDEO_Flags |= SDL_SWSURFACE;

    if (videodevice2 == NULL || *videodevice2 == 0) {
	videodevice2 = "/dev/video0";
    }

    if (avifilename2 == NULL || *avifilename2 == 0) {
	avifilename2 = "video2.avi";
    }

    videoIn2 = (struct vdIn*) calloc(1, sizeof(struct vdIn));
    if ( queryformats2 ) {
     /* if we're supposed to list the video formats, do that now and go out */
     	check_videoIn(videoIn2,(char *) videodevice2);
    	free(videoIn2);
	SDL_Quit();
	exit(1);
	}
    if (init_videoIn
	(videoIn2, (char *) videodevice2, width, height, fps, format,
	 grabmethod, avifilename2) < 0)
	exit(1);
 /* if we're supposed to list the controls, do that now */
    if ( querycontrols2 )
        enum_controls(videoIn2->fd);
    
    /* if we're supposed to read the control settings from a configfile, do that now */
    if ( readconfigfile2 )
        load_controls(videoIn2->fd);
	
    pscreen2 =
	SDL_SetVideoMode(videoIn2->width, videoIn2->height , 0,
			 SDL_VIDEO_Flags);

    overlay2 =
	SDL_CreateYUVOverlay(videoIn2->width, videoIn2->height ,
			     SDL_YUY2_OVERLAY, pscreen2);
    p2 = (unsigned char *) overlay2->pixels[0];
    drect2.x = 0;
    drect2.y = 0;
    drect2.w = pscreen2->w;
    drect2.h = pscreen2->h;
    if (enableRawStreamCapture2) {
		videoIn2->captureFile = fopen("stream2.raw", "wb");
		if(videoIn2->captureFile == NULL) {
			perror("Unable to open file for raw stream capturing");
		} else {
			printf("Starting raw stream capturing to stream.raw ...\n");
		}
    }
    if (enableRawFrameCapture2)
		videoIn2->rawFrameCapture = enableRawFrameCapture2;
initLut();
     const char video_name[]="video2";
    SDL_WM_SetCaption("video2"/*title_act[A_VIDEO].title*/, NULL);
    lasttime2 = SDL_GetTicks();
    creatButt(videoIn2->width, 32);
    SDL_LockYUVOverlay(overlay2);
    memcpy(p2 + (videoIn2->width * (videoIn2->height) * 2), YUYVbutt,
	   videoIn2->width * 64);
    SDL_UnlockYUVOverlay(overlay2);
    /* initialize thread data */
    ptdata2.ptscreen = &pscreen2;
    ptdata2.ptvideoIn = videoIn2;
    ptdata2.ptsdlevent = &sdlevent2;
    ptdata2.drect = &drect2;
    affmutex2 = SDL_CreateMutex();
    ptdata2.affmutex = affmutex2;
    mythread2 = SDL_CreateThread(eventThread, (void *) &ptdata2);
    /* main big loop */
     
     
    while (videoIn2->signalquit) {
	currtime2 = SDL_GetTicks();
	if (currtime2 - lasttime2 > 0) {
		frmrate = 1000/(currtime2 - lasttime2);
	}
	lasttime2 = currtime2;
        
	if (uvcGrab(videoIn2) < 0) {
	    printf("Error grabbing \n");
	    break;
	}
    
      
    /* if we're grabbing video, show the frame rate */
    if (videoIn2->toggleAvi)
        printf("\rframe rate: %d     ",frmrate);

	SDL_LockYUVOverlay(overlay2);
	memcpy(p2, videoIn2->framebuffer,
	       videoIn2->width * (videoIn2->height) * 2);
	SDL_UnlockYUVOverlay(overlay2);
	SDL_DisplayYUVOverlay(overlay2, &drect2);

           //videoIn2->getPict=1; ʐ^B悤ɂ

	if (videoIn2->getPict) { 
		switch(videoIn2->formatIn){
		case V4L2_PIX_FMT_MJPEG:
			get_picture(videoIn2->tmpbuffer,videoIn2->buf.bytesused);
			break;
		case V4L2_PIX_FMT_YUYV:
			get_pictureYV2(videoIn2->framebuffer,videoIn2->width,videoIn2->height,1);
			break;
		default:
		break;
		}
		videoIn2->getPict = 0;
		printf("get picture !\n");
	}

	SDL_LockMutex(affmutex2);
	ptdata2.frmrate = frmrate;
	SDL_WM_SetCaption(videoIn2->status, NULL);
	SDL_UnlockMutex(affmutex2);
	SDL_Delay(10);
      //get_pictureYV2(videoIn->framebuffer,320,240,pic_number); //Pʐ^ďI
        if(count_check) {         //5bɂPʐ^B邽߂̃vO
           count1=SDL_GetTicks();
           count_check=0;
          }
        count2=SDL_GetTicks();
        if(count2-count1>5000){
           get_pictureYV2(videoIn2->framebuffer,videoIn2->width,videoIn2->height,1);
              printf("get_picture!\n");
                 image_process(1);
              count_check=1;
          }
 
  /* close_v4l2(videoIn2);
    free(videoIn2);
   //return;
    destroyButt();
    freeLut();
    //printf(" Clean Up done Quit \n");
    //SDL_Quit();
    return;*/
    }
    
}


static int eventThread(void *data)
{
    struct pt_data *gdata = (struct pt_data *) data;
    struct v4l2_control control;
    SDL_Surface *pscreen = *gdata->ptscreen;
    struct vdIn *videoIn = gdata->ptvideoIn;
    SDL_Event *sdlevent = gdata->ptsdlevent;
    SDL_Rect *drect = gdata->drect;
    SDL_mutex *affmutex = gdata->affmutex;
    unsigned char frmrate;
    int x, y;
    int mouseon = 0;
    int value = 0;
    int len = 0;
    short incpantilt = INCPANTILT;
    int boucle = 0;
    action_gui curr_action = A_VIDEO;
    while (videoIn->signalquit) {
	SDL_LockMutex(affmutex);
	frmrate = gdata->frmrate;
	while (SDL_PollEvent(sdlevent)) {	//scan the event queue
	    switch (sdlevent->type) {
	    case SDL_KEYUP:
	    case SDL_MOUSEBUTTONUP:
		mouseon = 0;
		incpantilt = INCPANTILT;
		boucle = 0;
		break;
	    case SDL_MOUSEBUTTONDOWN:
		mouseon = 1;
	    case SDL_MOUSEMOTION:
		SDL_GetMouseState(&x, &y);
		//curr_action = GUI_whichbutton(x, y, pscreen, videoIn);
		break;
	    case SDL_VIDEORESIZE:
		pscreen =
		    SDL_SetVideoMode(sdlevent->resize.w,
				     sdlevent->resize.h, 0,
				     SDL_VIDEO_Flags);
		drect->w = sdlevent->resize.w;
		drect->h = sdlevent->resize.h;
		break;
	    case SDL_KEYDOWN:
		//curr_action = GUI_keytoaction(sdlevent->key.keysym.sym);
		if (curr_action != A_VIDEO)
		    mouseon = 1;
		break;
	    case SDL_QUIT:
		printf("\nStop asked\n");
		videoIn->signalquit = 0;
		break;
	    }
	}			//end if poll
	SDL_UnlockMutex(affmutex);
	/* traiter les actions */
	value = 0;
	if (mouseon){
	boucle++;
	switch (curr_action) {
	case A_BRIGHTNESS_UP:  
		if ((value =
		     v4l2UpControl(videoIn, V4L2_CID_BRIGHTNESS)) < 0)
		    printf("Set Brightness up error\n");
	    break;
	case A_CONTRAST_UP:
		if ((value =
		     v4l2UpControl(videoIn, V4L2_CID_CONTRAST)) < 0)
		    printf("Set Contrast up error \n");
	    break;
	case A_SATURATION_UP:
		if ((value =
		     v4l2UpControl(videoIn, V4L2_CID_SATURATION)) < 0)
		    printf("Set Saturation up error\n");
	    break;
	case A_GAIN_UP:
		if ((value = v4l2UpControl(videoIn, V4L2_CID_GAIN)) < 0)
		    printf("Set Gain up error\n");
	    break;
	case A_SHARPNESS_UP:
		if ((value =
		     v4l2UpControl(videoIn, V4L2_CID_SHARPNESS)) < 0)
		    printf("Set Sharpness up error\n");
	    break;
	case A_GAMMA_UP:
            if ((value = v4l2UpControl(videoIn, V4L2_CID_GAMMA)) < 0)
            printf("Set Gamma up error\n");
            break;
	case A_PAN_UP:
		if ((value =v4L2UpDownPan(videoIn, -incpantilt)) < 0)
		    printf("Set Pan up error\n");
	    break;
	    case A_TILT_UP:
		if ((value =v4L2UpDownTilt(videoIn, -incpantilt)) < 0)
		    printf("Set Tilt up error\n");
	    break;
	   case  A_PAN_RESET:
	   	if (v4l2ResetPanTilt(videoIn,1) < 0)
		    printf("reset pantilt error\n");
	   break;
	case A_SCREENSHOT:
		SDL_Delay(200);
		videoIn->getPict = 1;
		value = 1;
	    break;
	case A_RESET:
	   
		if (v4l2ResetControl(videoIn, V4L2_CID_BRIGHTNESS) < 0)
		    printf("reset Brightness error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_SATURATION) < 0)
		    printf("reset Saturation error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_CONTRAST) < 0)
		    printf("reset Contrast error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_HUE) < 0)
		    printf("reset Hue error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_SHARPNESS) < 0)
		    printf("reset Sharpness error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_GAMMA) < 0)
		    printf("reset Gamma error\n");
		if (v4l2ResetControl(videoIn, V4L2_CID_GAIN) < 0)
		    printf("reset Gain error\n");
		if (v4l2ResetPanTilt(videoIn,3) < 0)
		    printf("reset pantilt error\n");
	   
	    break;
	case A_BRIGHTNESS_DOWN:
		if ((value = v4l2DownControl(videoIn, V4L2_CID_BRIGHTNESS)) < 0)
		    printf("Set Brightness down error\n");
	    break;
	case A_CONTRAST_DOWN:
		if ((value = v4l2DownControl(videoIn, V4L2_CID_CONTRAST)) < 0)
		    printf("Set Contrast down error\n");
	    break;
	case A_SATURATION_DOWN:
		if ((value = v4l2DownControl(videoIn, V4L2_CID_SATURATION)) < 0)
		    printf("Set Saturation down error\n");
	    break;
	case A_GAIN_DOWN:
		if ((value = v4l2DownControl(videoIn, V4L2_CID_GAIN)) < 0)
		    printf("Set Gain down error\n");
	    break;
	case A_SHARPNESS_DOWN:
		if ((value = v4l2DownControl(videoIn, V4L2_CID_SHARPNESS)) < 0)
		    printf("Set Sharpness down error\n");
	    break;
	 case A_GAMMA_DOWN:
            if ((value = v4l2DownControl(videoIn, V4L2_CID_GAMMA)) < 0)
              printf("Set Gamma down error\n");
            break;   
	case A_PAN_DOWN: 
		if ((value =v4L2UpDownPan(videoIn, incpantilt)) < 0)	    
		    printf("Set Pan down error\n");
	    break;
	case A_TILT_DOWN: 
		if ((value =v4L2UpDownTilt(videoIn,incpantilt)) < 0)	    
		    printf("Set Tilt down error\n");
	    break;
	case A_TILT_RESET:
		if (v4l2ResetPanTilt(videoIn,2) < 0)
		    printf("reset pantilt error\n");
	    break;
	case A_RECORD_TOGGLE:
		SDL_Delay(200);
		videoIn->toggleAvi = !videoIn->toggleAvi;
		value = videoIn->toggleAvi;
        if ( value == 1 ) {
            printf("avi recording started\n");
            videoIn->recordstart=SDL_GetTicks();
        }
        else {
            int dur=SDL_GetTicks()-videoIn->recordstart;
            printf("\navi recording stopped (%ds)\n",dur/1000);
            videoIn->recordtime+=dur;
        }
	    break;
	case A_SWITCH_LIGHTFREQFILT: 
		if ((value =v4l2GetControl(videoIn,V4L2_CID_POWER_LINE_FREQUENCY)) < 0)	    
		    printf("Get value of light frequency filter error\n");

                 if(value < 2) // round switch 50->60->NoFliker->.
		    value++;   //		 \_______________; 
		 else
		    value=0;

		if(value == 0)
		    printf("Current light frequency filter: 50Hz\n");
		else if(value == 1)
		    printf("Current light frequency filter: 60Hz\n");
		else if(value == 2)
		    printf("Current light frequency filter: NoFliker\n");

		if ((value =v4l2SetLightFrequencyFilter(videoIn,value)) < 0)	    
		    printf("Switch light frequency filter error\n");


	    break;
	case A_QUIT:  
		videoIn->signalquit = 0;
	    break;
	case A_VIDEO:
	    break;
	case A_CAPTURE_FRAME:
		value = 1;
		videoIn->rawFrameCapture = 1;
		break;
	case A_CAPTURE_FRAMESTREAM:
		value = 1;
		if (!videoIn->rawFrameCapture) {
			videoIn->rawFrameCapture = 2;
			videoIn->rfsBytesWritten = 0;
			videoIn->rfsFramesWritten = 0;
			printf("Starting raw frame stream capturing ...\n");
		} else if(videoIn->framesWritten >= 5) {
			videoIn->rawFrameCapture = 0;
			printf("Stopped raw frame stream capturing. %u bytes written for %u frames.\n",
					videoIn->rfsBytesWritten, videoIn->rfsFramesWritten);
		}
		break;
	case A_CAPTURE_STREAM:
		value = 1;
		if (videoIn->captureFile == NULL) {
			videoIn->captureFile = fopen("stream.raw", "wb");
			if(videoIn->captureFile == NULL) {
				perror("Unable to open file for raw stream capturing");
			} else {
				printf("Starting raw stream capturing to stream.raw ...\n");
			}
			videoIn->bytesWritten = 0;
			videoIn->framesWritten = 0;
		} else if(videoIn->framesWritten >= 5) {
			fclose(videoIn->captureFile);
			printf("Stopped raw stream capturing to stream.raw. %u bytes written for %u frames.\n",
					videoIn->bytesWritten, videoIn->framesWritten);
			videoIn->captureFile = NULL;
		}
		break;
	 case A_EXPOSURE_UP:
            if ((value = v4l2UpControl(videoIn, V4L2_CID_EXPOSURE_ABSOLUTE)) < 0)
              printf("Set Absolute Exposure up error\n");
            break;
          case A_EXPOSURE_DOWN:
            if ((value = v4l2DownControl(videoIn, V4L2_CID_EXPOSURE_ABSOLUTE)) < 0)
              printf("Set Absolute Exposure down error\n");
            break;
          case A_EXPOSURE_ON:
            control.id    =V4L2_CID_EXPOSURE_AUTO;
            control.value =1;
            if ((value = ioctl(videoIn->fd, VIDIOC_S_CTRL, &control)) < 0)
              printf("Set Auto Exposure on error\n");
            else
              printf("Auto Exposure set to %d \n", control.value);
            break;
          case A_EXPOSURE_OFF:
            control.id    =V4L2_CID_EXPOSURE_AUTO;
            control.value =8;
            if ((value = ioctl(videoIn->fd, VIDIOC_S_CTRL, &control)) < 0)
              printf("Set Auto Exposure off error\n");
            else
              printf("Auto Exposure set to %d \n", control.value);
            break;
          case A_BALANCE_UP:
            if ((value = v4l2UpControl(videoIn, V4L2_CID_WHITE_BALANCE_TEMPERATURE)) < 0)
              printf("Set Balance Temperature up error\n");
            break;
          case A_BALANCE_DOWN:
            if ((value = v4l2DownControl(videoIn, V4L2_CID_WHITE_BALANCE_TEMPERATURE)) < 0)
              printf("Set Balance Temperature down error\n");
            break;
          case A_BALANCE_ON:
            control.id    =V4L2_CID_WHITE_BALANCE_TEMPERATURE_AUTO;
            control.value =1;
            if ((value = ioctl(videoIn->fd, VIDIOC_S_CTRL, &control)) < 0)
              printf("Set Auto Balance on error\n");
            else
              printf("Auto Balance set to %d \n", control.value);
            break;
          case A_BALANCE_OFF:
            control.id    =V4L2_CID_WHITE_BALANCE_TEMPERATURE_AUTO;
            control.value =0;
            if ((value = ioctl(videoIn->fd, VIDIOC_S_CTRL, &control)) < 0)
              printf("Set Auto Balance off error\n");
            else
              printf("Auto Balance set to %d \n", control.value);
            break;
          case A_SAVE:
	   printf("Save controls \n");
            save_controls(videoIn->fd);
            break;
          case A_LOAD:
	   printf("load controls \n");
            load_controls(videoIn->fd);
          break;
	default:
	    break;
	}
	if(!(boucle%10)) // smooth pan tilt method
		if(incpantilt < (10*INCPANTILT))
	   		 incpantilt += (INCPANTILT/4);
	if(value){
	len = strlen(title_act[curr_action].title)+8;
	snprintf(videoIn->status, len,"%s %06d",title_act[curr_action].title,value);
	}
	} else { // mouseon
       char *window_num=NULL;
       window_num = calloc(10,1);
      //snprintf(window_num, 10,"video%d",num);
	len = strlen(title_act[curr_action].title)+9;
	snprintf(videoIn->status, 10/*len*/,"%s","video2");
	
	}
	SDL_Delay(50);
	//printf("fp/s %d \n",frmrate);
    }				//end main loop

	/* Close the stream capture file */
	if (videoIn->captureFile) {
		fclose(videoIn->captureFile);
		printf("Stopped raw stream capturing to stream.raw. %u bytes written for %u frames.\n",
					videoIn->bytesWritten, videoIn->framesWritten);
	}
	/* Display stats for raw frame stream capturing */
	if (videoIn->rawFrameCapture == 2) {
		printf("Stopped raw frame stream capturing. %u bytes written for %u frames.\n",
					videoIn->rfsBytesWritten, videoIn->rfsFramesWritten);
	}
}
