// -*- C++ -*-
/*!
 * @file  Laser.cpp
 * @brief Console input component
 * $Date$
 *
 * $Id$
 */

#include "Laser.h"
#include "Laser.h"
#include "scip1.h"
#include "scip2.h"
#include "scipBase.h"
#include "scipUtil.h"

void TopURG(double x_axis[1000], double y_axis[1000]);

short i;

// Module specification
// <rtc-template block="module_spec">
static const char* laser_spec[] =
  {
    "implementation_id", "Laser",
    "type_name",         "Laser",
    "description",       "Console input component",
    "version",           "1.0",
    "vendor",            "MyName",
    "category",          "example",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

Laser::Laser(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    Laser_inIn("laser_in", Laser_in),
    Laser_outOut("laser_out", Laser_out),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("laser_in", Laser_inIn);
  
  // Set OutPort buffer
  registerOutPort("laser_out", Laser_outOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

Laser::~Laser()
{
}


RTC::ReturnCode_t Laser::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t Laser::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t Laser::onExecute(RTC::UniqueId ec_id)
{
	if (Laser_inIn.isNew())
	{
		Laser_inIn.read();
		if (Laser_in.data == 1)
		{
			double x_axis[1000];
			double y_axis[1000];

			//	$B%9%-%c%s(B
			TopURG(x_axis, y_axis);

			for (i=0;i<720;i++)
			{
				Laser_out.data.scan_x[i] = x_axis[i];
				Laser_out.data.scan_y[i] = y_axis[i];
			}
			Laser_outOut.write();
		}
	}
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t Laser::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Laser::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void LaserInit(RTC::Manager* manager)
  {
    RTC::Properties profile(laser_spec);
    manager->registerFactory(profile,
                             RTC::Create<Laser>,
                             RTC::Delete<Laser>);
  }
  
};

void TopURG(double x_axis[1000], double y_axis[1000])
{
  tPort *port;
  FILE *output;
  int **scan2;
  int i,j,id;
  int startStep,endStep,stepCluster,scanInterval,scanNum,stepNum;
  double x,y;

  // URG $B%;%s%5$H@\B3(B
  port=scipConnect("/dev/ttyACM0");
  if(port==NULL)
	{
    perror("Could not connect to the sensor ");
    exit(EXIT_FAILURE);
  }

  // SCIP2.0 $B%b!<%I$K0\9T(B
  switchToScip2(port);

  // $B=PNO%U%!%$%k$r3+$/(B
  output=fopen("log.txt","w");
  if(output==NULL)
	{
    perror("Could not open output file");
    exit(EXIT_FAILURE);
  }

  // $B%G!<%?<hF@%3%^%s%I!J(BMD$B%3%^%s%I!K$r(B1$B2sH/9T(B
  for(i=1; i<2; ++i)
	{
    printf("Trying #%d\n",i);

    // $B%9%-%c%s%Q%i%a!<%?$r@_Dj(B
    // $B%9%F%C%W(B 44-725 $B$NA4%9%F%C%WJ,$N5wN%%G!<%?$r4V0z$-$J$7$K(B2$B2s!J(B2$B%9%-%c%s!K<hF@(B
    startStep=180;
    endStep=900;
    stepCluster=1;
    scanInterval=0;
    scanNum=2;

    // $B?75,B,Dj$7$F%9%-%c%s%G!<%?$r<hF@(B[MD$B%3%^%s%I(B]
    scan2=scip2MeasureScan(port,startStep,endStep,stepCluster,scanInterval,scanNum,ENC_3BYTE,&stepNum);

		if(scan2!=NULL)
		{
			// $B<hF@$K@.8y$7$?$i%U%!%$%k$K5-O?(B
			for(j=0; j<scanNum; ++j)
			{
				for(id=0; id<stepNum; ++id)
				{
					// $B%(%i!<%3!<%IH=Dj!":BI8JQ49(B
          // $BJ}8~!J%9%F%C%WHV9f!K$HG[NsHV9f$OF15A$G$O$J$$$3$H$KCm0U(B
        if(scan2[j][id] >= 20 && scan2[j][id] <= 15000)
					{
						// $B@5>o(B
						x=scan2[j][id]*cos(((0.25*id)*M_PI)/180);//$B6K:BI8$+$iJQ49(B
						y=scan2[j][id]*sin(((0.25*id)*M_PI)/180);//$B6K:BI8$+$iJQ49(B
						//z=335;//$BD95wN%%l!<%6$N9b$5(B
          }
					else  // $B%(%i!<%3!<%I(B
						continue;

					//$BG[Ns$K=q$-9~$`(B
					if(x != 0 && y != 0)
					{
						x_axis[id]=x;
						y_axis[id]=y;
						//z_axis[id]=z;
					}
				}
			}

			//x $B:BI8CM!"(By $B:BI8CM$r%U%!%$%k$K5-O?(B
			for(id=1; id<stepNum+1; ++id)
			{
				fprintf(output,"%f %f \n",x_axis[id],y_axis[id]);
			}

			// malloc $B$7$?%9%-%c%s$N5wN%%G!<%?G[Ns$r(B free
			scip2FreeScan(scan2,scanNum);
		}
		else
		{
  		// $B<hF@$K<:GT(B
			fprintf(stderr,"#%d failed %s %s %d\n",i,__FILE__,__FUNCTION__,__LINE__);
		}
  }

  // $B;XDj$5$l$?DL?.%O%s%I%k$rJD$8$k(B
  closePort(port);

  fclose(output);
}
